/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Annotation of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.29 - (hide annotations) (download)
Tue Nov 11 20:38:27 2003 UTC (20 years, 4 months ago) by edhill
Branch: MAIN
Changes since 1.28: +95 -5 lines
 o add various compilation tests to genmake2 so that it acts more
   like a typical autoconf-generated "./configure" script:
   - HAVE_SYSTEM
   - HAVE_FDATE
   - FC_NAMEMANGLE.h
 o small code modifications to use the above #define-s

1 edhill 1.1 #!/bin/bash
2     #
3 edhill 1.29 # $Header: /u/u3/gcmpack/MITgcm/tools/genmake2,v 1.28 2003/11/04 19:51:54 edhill Exp $
4 edhill 1.1 #
5     # Makefile generator for MITgcm UV codes
6     # created by cnh 03/98
7     # adapted by aja 06/98
8     # modified by aja 01/00
9     # rewritten in bash by eh3 08/03
10    
11 edhill 1.12 # Search for particular CPP #cmds associated with packages
12     # usage: test_for_package_in_cpp_options CPP_file package_name
13     test_for_package_in_cpp_options() {
14     cpp_options=$1
15     pkg=$2
16     grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17     RETVAL=$?
18     if test "x${RETVAL}" = x0 ; then
19     echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20     exit 99
21     fi
22     grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23     RETVAL=$?
24     if test "x${RETVAL}" = x0 ; then
25     echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26     exit 99
27     fi
28     grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29     RETVAL=$?
30     if test "x${RETVAL}" = x0 ; then
31     echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32     exit 99
33     fi
34     grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35     RETVAL=$?
36     if test "x${RETVAL}" = x0 ; then
37     echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38     exit 99
39     fi
40     }
41    
42     # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43     # the package list.
44     expand_pkg_groups() {
45     new_packages=
46     PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47     if test -r $PKG_GROUPS ; then
48     cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49 edhill 1.15 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50 edhill 1.12 matched=0
51     for i in $PACKAGES ; do
52     line=`grep "^ *$i" ./p2.tmp`
53     RETVAL=$?
54     if test "x$RETVAL" = x0 ; then
55     matched=1
56 edhill 1.15 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
57 edhill 1.12 echo " replacing \"$i\" with: $replace"
58     new_packages="$new_packages $replace"
59     else
60     new_packages="$new_packages $i"
61     fi
62     done
63     PACKAGES=$new_packages
64     rm -f ./p[1,2].tmp
65     else
66     echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67     fi
68     }
69 edhill 1.1
70     # Guess possible config options for this host
71     find_possible_configs() {
72    
73 edhill 1.11 tmp1=`uname`"_"`uname -m`
74     tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75 edhill 1.25 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
76     PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
77 edhill 1.11 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
78     echo " The platform appears to be: $PLATFORM"
79     # if test "x$OFLIST" = x ; then
80     # echo " No pre-defined options files were found matching this platform"
81     # echo " but examples for other platforms can be found in:"
82     # echo " $ROOTDIR/tools/build_options"
83     # else
84     # echo " Options files (located in $ROOTDIR/tools/build_options) that"
85     # echo " may work with this machine are:"
86     # for i in $OFLIST ; do
87     # echo " $i"
88     # done
89     # fi
90    
91 edhill 1.1 echo "test" > test
92     ln -s ./test link
93     RETVAL=$?
94     if test "x${RETVAL}" = x0 ; then
95 edhill 1.11 LN="ln -s"
96     else
97     echo "Error: \"ln -s\" does not appear to work on this system!"
98     echo " For help, please contact <MITgcm-support@mitgcm.org>."
99     exit 1
100 edhill 1.1 fi
101     rm -f test link
102    
103 edhill 1.11 if test "x$CPP" = x ; then
104     CPP="cpp -traditional -P"
105 edhill 1.1 fi
106    
107     # look for possible fortran compilers
108 cnh 1.24 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
109 edhill 1.1 p_FC=
110 edhill 1.11 for c in $tmp ; do
111     rm -f ./hello.f ./hello
112     cat >> hello.f <<EOF
113     program hello
114     do i=1,3
115     print *, 'hello world : ', i
116     enddo
117     end
118     EOF
119     $c -o hello hello.f > /dev/null 2>&1
120 edhill 1.1 RETVAL=$?
121     if test "x${RETVAL}" = x0 ; then
122     p_FC="$p_FC $c"
123     fi
124     done
125 edhill 1.21 rm -f ./hello.f ./hello
126 edhill 1.1 if test "x${p_FC}" = x ; then
127 edhill 1.11 cat 1>&2 <<EOF
128    
129     Error: No Fortran compilers were found in your path. Please specify one using:
130    
131     1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
132     2) a command-line option (eg. "-fc NAME"), or
133     3) the MITGCM_FC environment variable.
134    
135     EOF
136     exit 1
137 edhill 1.1 else
138 edhill 1.11 echo " The possible FORTRAN compilers found in your path are:"
139     echo " "$p_FC
140     if test "x$FC" = x ; then
141 edhill 1.15 FC=`echo $p_FC | $AWK '{print $1}'`
142 edhill 1.11 fi
143 edhill 1.1 fi
144    
145 edhill 1.11 for i in $p_FC ; do
146     p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
147     if test -r $p_OF ; then
148     OPTFILE=$p_OF
149     echo " The options file: $p_OF"
150     echo " appears to match so we'll use it."
151     break
152     fi
153     done
154     if test "x$OPTFILE" = x ; then
155     cat 1>&2 <<EOF
156    
157     Error: No options file was found in: $ROOTDIR/tools/build_options/
158     that matches this platform ("$PLATFORM") and the compilers found in
159     your path. Please specify an "optfile" using:
160    
161     1) the command line (eg. "-optfile=path/to/OPTFILE"), or
162     2) the MITGCM_OF environment variable.
163    
164     If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
165    
166 edhill 1.1 EOF
167 edhill 1.11 exit 1
168 edhill 1.1 fi
169 edhill 1.11
170     # # look for possible MPI libraries
171     # mpi_libs=
172     # mpi_fort=`which mpif77 2>/dev/null`
173     # RETVAL=$?
174     # if test "x${RETVAL}" = x0 ; then
175     # cat >>test.f <<EOF
176     # PROGRAM HELLO
177     # DO 10, I=1,10
178     # PRINT *,'Hello World'
179     # 10 CONTINUE
180     # STOP
181     # END
182     # EOF
183     # eval "$mpi_fort -showme test.f > out"
184     # RETVAL=$?
185     # if test "x${RETVAL}" = x0 ; then
186     # a=`cat out`
187     # for i in $a ; do
188     # case $i in
189     # -*)
190     # mpi_libs="$mpi_libs $i" ;;
191     # esac
192     # done
193     # echo "The MPI libs appear to be:"
194     # echo " "$mpi_libs
195     # fi
196     # rm -f test.f out
197     # fi
198 edhill 1.1
199     }
200    
201     # Parse the package dependency information
202     get_pdepend_list() {
203    
204     # strip the comments and then convert the dependency file into
205     # two arrays: PNAME, DNAME
206     cat $1 | sed -e 's/#.*$//g' \
207 edhill 1.15 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
208 edhill 1.1 > ./.pd_tmp
209     source ./.pd_tmp
210     rm -f ./.pd_tmp
211    
212     echo -n "PNAME = "${}
213     }
214    
215    
216     # Explain usage
217     usage() {
218 edhill 1.2 echo
219 edhill 1.1 echo "Usage: "$0" [OPTIONS]"
220 edhill 1.2 echo " where [OPTIONS] can be:"
221     echo
222 edhill 1.1 echo " -help | --help | -h | --h"
223     echo " -nooptfile | --nooptfile"
224     echo " -optfile NAME | --optfile NAME | -of NAME | --of NAME"
225     echo " -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"
226     echo " -pdepend NAME | --pdepend NAME"
227     echo " -pdepend=NAME | --pdepend=NAME"
228     echo " -pdefault NAME | --pdefault NAME"
229     echo " -pdefault=NAME | --pdefault=NAME"
230 edhill 1.6 echo " -make NAME | -m NAME"
231     echo " --make=NAME | -m=NAME"
232     echo " -makefile NAME | -mf NAME"
233     echo " --makefile=NAME | -mf=NAME"
234 edhill 1.1 echo " -platform NAME | --platform NAME | -pl NAME | --pl NAME"
235     echo " -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"
236     echo " -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"
237     echo " -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"
238     echo " -mods NAME | --mods NAME | -mo NAME | --mo NAME"
239     echo " -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"
240     echo " -disable NAME | --disable NAME"
241     echo " -disable=NAME | --disable=NAME"
242     echo " -enable NAME | --enable NAME"
243     echo " -enable=NAME | --enable=NAME"
244 edhill 1.12 echo " -standarddirs NAME | --standarddirs NAME"
245     echo " -standarddirs=NAME | --standarddirs=NAME"
246 edhill 1.1 echo " -noopt NAME | --noopt NAME"
247     echo " -noopt=NAME | --noopt=NAME"
248     # echo " -cpp NAME | --cpp NAME"
249     # echo " -cpp=NAME | --cpp=NAME"
250     echo " -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"
251     echo " -fc=NAME | --fc=NAME"
252     echo " -[no]ieee | --[no]ieee"
253     echo " -[no]mpi | --[no]mpi"
254 edhill 1.2 echo " -[no]jam | --[no]jam"
255     echo
256     echo " and NAME is a string such as:"
257     echo
258 edhill 1.1 echo " --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'"
259     echo " -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'"
260 edhill 1.2 echo " -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"
261     echo
262 edhill 1.1 echo " which, depending upon your shell, may need to be single-quoted"
263     echo " if it contains spaces, dashes, or other special characters."
264     exit 1
265     }
266    
267     #eh3 # This is the generic configuration.
268     #eh3 set LN = ( 'ln -s' )
269     #eh3 set CPP = ( '/lib/cpp -P' )
270     #eh3 set S64 = ( '$(TOOLSDIR)/set64bitConst.sh' )
271     #eh3 set KPP = ( )
272     #eh3 set FC = ( 'f77' )
273     #eh3 set LINK = $FC
274     #eh3 set MAKEDEPEND = ( 'makedepend' )
275     #eh3 set INCLUDES = ( -I. )
276     #eh3 set FFLAGS = ( )
277     #eh3 set FOPTIM = ( )
278     #eh3 set CFLAGS = ( )
279     #eh3 set KFLAGS1 = ( )
280     #eh3 set KFLAGS2 = ( )
281     #eh3 set LIBS = ( )
282     #eh3 set KPPFILES = ( )
283     #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = ( )
284     #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = ( )
285    
286     # Set defaults here
287 edhill 1.5 COMMANDL="$0 $@"
288    
289 edhill 1.1 PLATFORM=
290     LN=
291     S64=
292     KPP=
293     FC=
294     LINK=
295 edhill 1.11 DEFINES="-DWORDLENGTH=4"
296 edhill 1.1 PACKAGES=
297     ENABLE=
298     DISABLE=
299     MAKEFILE=
300     MAKEDEPEND=
301     PDEPEND=
302 edhill 1.11 DUMPSTATE=t
303 edhill 1.1 PDEFAULT=
304     OPTFILE=
305 edhill 1.2 INCLUDES="-I."
306 edhill 1.1 FFLAGS=
307     FOPTIM=
308     CFLAGS=
309     KFLAGS1=
310     KFLAGS2=
311     LIBS=
312     KPPFILES=
313     NOOPTFILES=
314     NOOPTFLAGS=
315    
316 edhill 1.29 # DEFINES checked by test compilation
317     HAVE_SYSTEM=
318     HAVE_FDATE=
319     FC_NAMEMANGLE=
320    
321 edhill 1.1 MODS=
322     TOOLSDIR=
323     SOURCEDIRS=
324     INCLUDEDIRS=
325 edhill 1.12 STANDARDDIRS=
326 edhill 1.1
327     PWD=`pwd`
328     MAKE=make
329 edhill 1.15 AWK=awk
330 edhill 1.1 THISHOSTNAME=`hostname`
331     THISCWD=`pwd`
332     THISDATE=`date`
333     MACHINE=`uname -a`
334 edhill 1.7 EXECUTABLE=
335     EXEHOOK=
336     EXEDIR=
337 edhill 1.12 PACKAGES_CONF=
338     IEEE=
339     if test "x$MITGCM_IEEE" != x ; then
340     IEEE=$MITGCM_IEEE
341     fi
342 edhill 1.1
343 edhill 1.14 AUTODIFF_PKG_USED=f
344     AD_OPTFILE=
345 edhill 1.17 TAF=
346     AD_TAF_FLAGS=
347     FTL_TAF_FLAGS=
348     SVD_TAF_FLAGS=
349     TAF_EXTRA=
350     TAMC=
351     AD_TAMC_FLAGS=
352     FTL_TAF_FLAGS=
353     SVD_TAMC_FLAGS=
354     TAMC_EXTRA=
355    
356 edhill 1.14
357 edhill 1.5 # The following state can be set directly by command-line switches
358     gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
359 edhill 1.12 gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
360 edhill 1.5
361     # The following state is not directly set by command-line switches
362     gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
363     gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
364     gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
365 edhill 1.12 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
366 edhill 1.29 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
367 edhill 1.5
368 edhill 1.14 # The following are all related to adjoint/tangent-linear stuff
369 edhill 1.29 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
370     gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
371     gm_s12="TAF_EXTRA TAMC_EXTRA"
372 edhill 1.14
373 edhill 1.29 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
374     gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
375 edhill 1.5
376    
377 edhill 1.2 echo
378     echo "=== Processing options files and arguments ==="
379 edhill 1.12 gm_local="genmake_local"
380     for i in . $MODS ; do
381     if test -r $i/$gm_local ; then
382     source $i/$gm_local
383     break
384     fi
385     done
386 edhill 1.1 echo -n " getting local config information: "
387     if test -e $gm_local ; then
388     echo "using $gm_local"
389     source $gm_local
390 edhill 1.2 # echo "DISABLE=$DISABLE"
391     # echo "ENABLE=$ENABLE"
392 edhill 1.1 else
393     echo "none found"
394     fi
395    
396     # echo "$0::$1:$2:$3:$4:$5:$6:$7:"
397 edhill 1.2 #OPTIONS=
398     #n=0
399     #for i ; do
400     # echo "$i $n"
401     # setvar="OPTIONS[$n]='$i'"
402     # # echo " $setvar"
403     # eval "$setvar"
404     # n=$(( $n + 1 ))
405     #done
406     #parse_options
407     ac_prev=
408     for ac_option ; do
409    
410     # If the previous option needs an argument, assign it.
411     if test -n "$ac_prev"; then
412     eval "$ac_prev=\$ac_option"
413     ac_prev=
414     continue
415     fi
416    
417     ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
418    
419     case $ac_option in
420    
421     -help | --help | -h | --h)
422     usage ;;
423    
424     -nooptfile | --nooptfile)
425     OPTFILE="NONE" ;;
426     -optfile | --optfile | -of | --of)
427 edhill 1.4 ac_prev=OPTFILE ;;
428 edhill 1.2 -optfile=* | --optfile=* | -of=* | --of=*)
429     OPTFILE=$ac_optarg ;;
430    
431 edhill 1.14 -adoptfile | --adoptfile | -ad | --ad)
432     ac_prev=AD_OPTFILE ;;
433     -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
434     AD_OPTFILE=$ac_optarg ;;
435    
436 edhill 1.2 -pdepend | --pdepend)
437 edhill 1.4 ac_prev=PDEPEND ;;
438 edhill 1.2 -pdepend=* | --pdepend=*)
439     PDEPEND=$ac_optarg ;;
440    
441     -pdefault | --pdefault)
442 edhill 1.4 ac_prev=PDEFAULT ;;
443 edhill 1.2 -pdefault=* | --pdefault=*)
444     PDEFAULT=$ac_optarg ;;
445    
446 edhill 1.6 -make | --make | -m | --m)
447     ac_prev=MAKE ;;
448     -make=* | --make=* | -m=* | --m=*)
449     MAKE=$ac_optarg ;;
450    
451     -makefile | --makefile | -ma | --ma)
452 edhill 1.4 ac_prev=MAKEFILE ;;
453 edhill 1.6 -makefile=* | --makefile=* | -ma=* | --ma=*)
454 edhill 1.2 MAKEFILE=$ac_optarg ;;
455    
456     -platform | --platform | -pl | --pl)
457 edhill 1.4 ac_prev=PLATFORM ;;
458 edhill 1.2 -platform=* | --platform=* | -pl=* | --pl=*)
459     PLATFORM=$ac_optarg ;;
460    
461     -rootdir | --rootdir | -rd | --rd)
462 edhill 1.4 ac_prev=ROOTDIR ;;
463 edhill 1.2 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
464     ROOTDIR=$ac_optarg ;;
465    
466     -mods | --mods | -mo | --mo)
467 edhill 1.4 ac_prev=MODS ;;
468 edhill 1.2 -mods=* | --mods=* | -mo=* | --mo=*)
469     MODS=$ac_optarg ;;
470    
471     -disable | --disable)
472 edhill 1.4 ac_prev=DISABLE ;;
473 edhill 1.2 -disable=* | --disable=*)
474     DISABLE=$ac_optarg ;;
475    
476     -enable | --enable)
477 edhill 1.4 ac_prev=ENABLE ;;
478 edhill 1.2 -enable=* | --enable=*)
479     ENABLE=$ac_optarg ;;
480    
481 edhill 1.12 -standarddirs | --standarddirs)
482     ac_prev=STANDARDDIRS ;;
483     -standarddirs=* | --standarddirs=*)
484     STANDARDDIRS=$ac_optarg ;;
485    
486 edhill 1.2 -noopt | --noopt)
487 edhill 1.4 ac_prev=NOOPT ;;
488 edhill 1.2 -noopt=* | --noopt=*)
489     NOOPT=$ac_optarg ;;
490    
491     # -cpp | --cpp)
492     # ac_prev=cpp ;;
493     # -cpp=* | --cpp=*)
494     # CPP=$ac_optarg ;;
495    
496     -fortran | --fortran | -fc | --fc)
497 edhill 1.4 ac_prev=FC ;;
498 edhill 1.2 -fc=* | --fc=*)
499     FC=$ac_optarg ;;
500    
501     -ieee | --ieee)
502 edhill 1.12 IEEE=true ;;
503 edhill 1.2 -noieee | --noieee)
504 edhill 1.12 IEEE= ;;
505 edhill 1.2
506     -mpi | --mpi)
507 edhill 1.12 MPI=true ;;
508 edhill 1.2 -nompi | --nompi)
509 edhill 1.12 MPI= ;;
510 edhill 1.2
511     -jam | --jam)
512     JAM=1 ;;
513     -nojam | --nojam)
514     JAM=0 ;;
515    
516 edhill 1.5 -ds | --ds)
517     DUMPSTATE=t ;;
518    
519 edhill 1.17 -taf_extra | --taf_extra)
520     ac_prev=TAF_EXTRA ;;
521     -taf_extra=* | --taf_extra=*)
522     TAF_EXTRA=$ac_optarg ;;
523    
524     -tamc_extra | --tamc_extra)
525     ac_prev=TAMC_EXTRA ;;
526     -tamc_extra=* | --tamc_extra=*)
527     TAMC_EXTRA=$ac_optarg ;;
528    
529 edhill 1.2 -*)
530     echo "Error: unrecognized option: "$ac_option
531     usage
532     ;;
533    
534     *)
535     echo "Error: unrecognized argument: "$ac_option
536     usage
537     ;;
538    
539     esac
540    
541 edhill 1.1 done
542    
543 edhill 1.12 if test -f ./.genmakerc ; then
544     echo
545     echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
546     echo " file. This file format is no longer supported. Please see:"
547     echo
548     echo " http://mitgcm.org/devel_HOWTO/"
549     echo
550     echo " for directions on how to setup and use the new \"genmake2\" input"
551     echo " files and send an email to MITgcm-support@mitgcm.org if you want help."
552     echo
553     fi
554    
555 edhill 1.11 if test "x${ROOTDIR}" = x ; then
556     if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
557     ROOTDIR=".."
558     else
559     for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
560     if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
561     ROOTDIR=$d
562     echo -n "Warning: ROOTDIR was not specified but there appears to be"
563     echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
564     break
565     fi
566     done
567     fi
568     fi
569     if test "x${ROOTDIR}" = x ; then
570     echo "Error: Cannot determine ROOTDIR for MITgcm code."
571     echo " Please specify a ROOTDIR using either an options "
572     echo " file or a command-line option."
573     exit 1
574     fi
575     if test ! -d ${ROOTDIR} ; then
576     echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
577     exit 1
578     fi
579    
580 edhill 1.1 echo " getting OPTFILE information: "
581     if test "x${OPTFILE}" = x ; then
582 edhill 1.11 if test "x$MITGCM_OF" = x ; then
583     echo "Warning: no OPTFILE specified so we'll look for possible settings"
584     printf "\n=== Searching for possible settings for OPTFILE ===\n"
585     find_possible_configs
586 edhill 1.1 else
587 edhill 1.11 OPTFILE=$MITGCM_OF
588     fi
589     fi
590     if test "x$OPTFILE" != xNONE ; then
591     if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
592     echo " using OPTFILE=\"$OPTFILE\""
593     source "$OPTFILE"
594     RETVAL=$?
595     if test "x$RETVAL" != x0 ; then
596     echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
597     echo "--please check that variable syntax is bash-compatible"
598 edhill 1.1 exit 1
599     fi
600 edhill 1.11 if test "x$DUMPSTATE" != xf ; then
601 edhill 1.12 cp -f $OPTFILE "genmake_optfile"
602 edhill 1.11 fi
603     else
604     echo "Error: can't read OPTFILE=\"$OPTFILE\""
605     exit 1
606 edhill 1.1 fi
607     fi
608 edhill 1.8
609 edhill 1.14 echo " getting AD_OPTFILE information: "
610     if test "x${AD_OPTFILE}" = x ; then
611     if test "x$MITGCM_AD_OF" = x ; then
612     AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
613     else
614     AD_OPTFILE=$MITGCM_AD_OF
615     fi
616     fi
617     if test "x${AD_OPTFILE}" != xNONE ; then
618     if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
619     echo " using AD_OPTFILE=\"$AD_OPTFILE\""
620     source "$AD_OPTFILE"
621     RETVAL=$?
622     if test "x$RETVAL" != x0 ; then
623     echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
624     echo "--please check that variable syntax is bash-compatible"
625     exit 1
626     fi
627     if test "x$DUMPSTATE" != xf ; then
628     cp -f $AD_OPTFILE "genmake_ad_optfile"
629     fi
630     else
631     echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
632     exit 1
633     fi
634     fi
635    
636 edhill 1.8 # Check that FC, LINK, CPP, and S64 are defined. If not, complain
637     # and abort!
638     if test "x$FC" = x ; then
639     cat <<EOF 1>&2
640    
641     Error: no Fortran compiler: please specify using one of the following:
642     1) within the options file ("FC=...") as specified by "-of=OPTFILE"
643     2) the "-fc=XXX" command-line option
644 edhill 1.12 3) the "./genmake_local" file
645 edhill 1.8 EOF
646     exit 1
647     fi
648     if test "x$LINK" = x ; then
649     LINK=$FC
650     fi
651     if test "x$CPP" = x ; then
652 edhill 1.11 CPP="cpp"
653     fi
654 edhill 1.13 echo "#define A a" | $CPP > test_cpp 2>&1
655 edhill 1.11 RETVAL=$?
656     if test "x$RETVAL" != x0 ; then
657 edhill 1.8 cat <<EOF 1>&2
658    
659 edhill 1.11 Error: C pre-processor "$CPP" failed the test case: please specify using:
660    
661 edhill 1.8 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
662 edhill 1.12 2) the "./genmake_local" file
663 edhill 1.11
664 edhill 1.8 EOF
665     exit 1
666 edhill 1.11 else
667     rm -f test_cpp
668 edhill 1.8 fi
669 edhill 1.11 if test "x$MAKEDEPEND" = x ; then
670     MAKEDEPEND=makedepend
671 edhill 1.8 fi
672 edhill 1.29
673    
674     printf "\n=== Checking system libraries ===\n"
675     echo -n " Do we have the system() command using $FC... "
676     cat > genmake_tcomp.f <<EOF
677     program hello
678     call system('echo hi')
679     end
680     EOF
681     $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
682     RETVAL=$?
683     if test "x$RETVAL" = x0 ; then
684     HAVE_SYSTEM=t
685     DEFINES="$DEFINES -DHAVE_SYSTEM"
686     echo "yes"
687     else
688     HAVE_SYSTEM=
689     echo "no"
690     fi
691     rm -f genmake_tcomp*
692    
693     echo -n " Do we have the fdate() command using $FC... "
694     cat > genmake_tcomp.f <<EOF
695     program hello
696     CHARACTER(128) string
697     string = ' '
698     call fdate( string )
699     print *, string
700     end
701     EOF
702     $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
703     RETVAL=$?
704     if test "x$RETVAL" = x0 ; then
705     HAVE_FDATE=t
706     DEFINES="$DEFINES -DHAVE_FDATE"
707     echo "yes"
708     else
709     HAVE_FDATE=
710     echo "no"
711     fi
712     rm -f genmake_tcomp*
713    
714     echo -n " The name mangling convention for $FC is... "
715     if test "x$FC_NAMEMANGLE" = x ; then
716     FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"
717     fi
718     cat > genmake_tcomp.f <<EOF
719     subroutine tcall( string )
720     character*(*) string
721     call tsub( string )
722     end
723     EOF
724     $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1
725     RETVAL=$?
726     if test "x$RETVAL" != x0 ; then
727     cat genmake_tcomp.log >> genmake_errors
728     echo
729     echo "WARNING: test compile fails -- please see \"genmake_errors\""
730     echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
731     echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
732     else
733     tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`
734     RETVAL=$?
735     if test "x$RETVAL" != x0 ; then
736     echo
737     echo "WARNING: The \"nm\" command failed."
738     echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
739     echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
740     else
741     t0=`echo $tcall | sed -e 's|_tcall|_ ## X|g'`
742     nmres=`echo $t0 | sed -e 's|tcall_|X ## _|g'`
743     FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmres"
744     echo "'$FC_NAMEMANGLE'"
745     fi
746     fi
747     echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template
748     cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1
749     RETVAL=$?
750     if test "x$RETVAL" != x0 ; then
751     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h
752     fi
753     rm -f genmake_tcomp*
754    
755 edhill 1.8
756 edhill 1.2 printf "\n=== Setting defaults ===\n"
757 edhill 1.1 echo -n " Adding MODS directories: "
758     for d in $MODS ; do
759     if test ! -d $d ; then
760 edhill 1.2 echo
761     echo "Error: MODS directory \"$d\" not found!"
762 edhill 1.1 exit 1
763     else
764     echo -n " $d"
765     SOURCEDIRS="$SOURCEDIRS $d"
766     INCLUDEDIRS="$INCLUDEDIRS $d"
767     fi
768     done
769     echo
770    
771     if test "x$MAKEFILE" = x ; then
772     MAKEFILE="Makefile"
773     fi
774     if test "x${PLATFORM}" = x ; then
775     PLATFORM=$p_PLATFORM
776     fi
777    
778     if test "x${EXEDIR}" = x ; then
779     if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
780     EXEDIR=../exe
781     else
782     EXEDIR=.
783     fi
784     fi
785     if test ! -d ${EXEDIR} ; then
786     echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
787     exit 1
788     fi
789    
790     if test "x${TOOLSDIR}" = x ; then
791     TOOLSDIR="$ROOTDIR/tools"
792     fi
793     if test ! -d ${TOOLSDIR} ; then
794     echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"
795     exit 1
796     fi
797 edhill 1.11 if test "x$S64" = x ; then
798     S64='$(TOOLSDIR)/set64bitConst.sh'
799     fi
800 edhill 1.1
801     EXECUTABLE=${EXECUTABLE:-mitgcmuv}
802    
803     # We have a special set of source files in eesupp/src which are
804     # generated from some template source files. We'll make them first so
805     # they appear as regular source code
806     if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
807     echo " Making source files in eesupp from templates"
808     $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1
809     RETVAL=$?
810 edhill 1.2 if test "x${RETVAL}" = x0 ; then
811 edhill 1.1 rm -f make_eesupp.errors
812     else
813     echo "Error: problem encountered while building source files in eesupp:"
814     cat make_eesupp.errors
815     exit 1
816     fi
817     fi
818    
819 edhill 1.2 printf "\n=== Determining package settings ===\n"
820 edhill 1.1 if test "x${PDEPEND}" = x ; then
821     tmp=$ROOTDIR"/pkg/pkg_depend"
822     if test -r $tmp ; then
823     PDEPEND=$tmp
824     else
825     echo "Warning: No package dependency information was specified."
826     echo " Please check that ROOTDIR/pkg/pkg_depend exists."
827     fi
828     else
829     if test ! -r ${PDEPEND} ; then
830     echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
831     exit 1
832     fi
833     fi
834     echo " getting package dependency info from $PDEPEND"
835     # Strip the comments and then convert the dependency file into
836     # two arrays: PNAME, DNAME
837     cat $PDEPEND | sed -e 's/#.*$//g' \
838 edhill 1.15 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
839 edhill 1.1 > ./.pd_tmp
840     RETVAL=$?
841     if test ! "x${RETVAL}" = x0 ; then
842     echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
843     exit 1
844     fi
845     source ./.pd_tmp
846     rm -f ./.pd_tmp
847    
848 edhill 1.12 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
849     # file should eventually be added so that, for convenience, one can
850     # specify groups of packages using names like "ocean" and "atmosphere".
851 edhill 1.1 echo -n " checking default package list: "
852     if test "x${PDEFAULT}" = x ; then
853 edhill 1.12 for i in "." $MODS ; do
854     if test -r $i"/packages.conf" ; then
855     PDEFAULT=$i"/packages.conf"
856     break
857     fi
858     done
859     fi
860     if test "x${PDEFAULT}" = x ; then
861 edhill 1.1 PDEFAULT="$ROOTDIR/pkg/pkg_default"
862     fi
863     if test "x${PDEFAULT}" = xNONE ; then
864     echo "default packages file disabled"
865     else
866     if test ! -r $PDEFAULT ; then
867     echo ""
868     echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
869     else
870     echo " using PDEFAULT=\"$PDEFAULT\""
871     # Strip the comments and add all the names
872 edhill 1.15 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
873 edhill 1.1 RETVAL=$?
874     if test "x${RETVAL}" != x0 ; then
875     echo -n "Error: can't parse default package list "
876     echo "-- please check PDEFAULT=\"$PDEFAULT\""
877     exit 1
878     fi
879     for i in $def ; do
880     PACKAGES="$PACKAGES $i"
881     done
882 edhill 1.12 echo " before group expansion packages are: $PACKAGES"
883     expand_pkg_groups
884     echo " after group expansion packages are: $PACKAGES"
885 edhill 1.1 fi
886     fi
887    
888     echo " applying DISABLE settings"
889     pack=
890     for p in $PACKAGES ; do
891     addit="t"
892     for d in $DISABLE ; do
893     if test "x$p" = "x$d" ; then
894     addit="f"
895     fi
896     done
897     if test "x$addit" = xt ; then
898     pack="$pack $p"
899     fi
900     done
901     PACKAGES="$pack"
902     echo " applying ENABLE settings"
903 edhill 1.12 echo "" > ./.tmp_pack
904 edhill 1.1 PACKAGES="$PACKAGES $ENABLE"
905     for i in $PACKAGES ; do
906     if test ! -d "$ROOTDIR/pkg/$i" ; then
907     echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
908     exit 1
909     fi
910     echo $i >> ./.tmp_pack
911     done
912     pack=`cat ./.tmp_pack | sort | uniq`
913     rm -f ./.tmp_pack
914     PACKAGES=
915     for i in $pack ; do
916     PACKAGES="$PACKAGES $i"
917     done
918     echo " packages are: $PACKAGES"
919    
920     echo " applying package dependency rules"
921     ck=
922     while test "x$ck" != xtt ; do
923     i=0
924 edhill 1.2 # rtot=${#PNAME[@]}
925     rtot=$nname
926 edhill 1.1 while test $i -lt $rtot ; do
927    
928     # Is $pname in the current $PACKAGES list?
929 edhill 1.2 # pname=${PNAME[$i]}
930     tmp="pname=\"\$PNAME_$i\""
931     eval $tmp
932 edhill 1.1 pin="f"
933     for p in $PACKAGES ; do
934     if test "x$p" = "x$pname" ; then
935     pin="t"
936     fi
937     done
938    
939     # Is the DNAME entry a (+) or (-) rule ?
940 edhill 1.2 tmp="dname=\"\$DNAME_$i\""
941     eval $tmp
942 edhill 1.1 plus="-"
943 edhill 1.2 echo $dname | grep '^+' > /dev/null 2>&1
944 edhill 1.1 RETVAL=$?
945     if test "x$RETVAL" = x0 ; then
946     plus="+"
947     fi
948    
949     # Is $dname in the current $PACKAGES list?
950 edhill 1.2 dname=`echo $dname | sed -e 's/^[+-]//'`
951 edhill 1.1 din="f"
952     for p in $PACKAGES ; do
953     if test "x$p" = "x$dname" ; then
954     din="t"
955     fi
956     done
957    
958     # Do we need to add $dname according to the dependency rules?
959     if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
960     in_dis="f"
961     for dis in $DISABLE ; do
962     if test "x$dis" = "x$dname" ; then
963     in_dis="t"
964     fi
965     done
966     if test "x$in_dis" = xt ; then
967     echo "Error: can't satisfy package dependencies:"
968     echo " \"$dname\" is required by the dependency rules"
969     echo " but is disallowed by the DISABLE settings"
970     exit 1
971     else
972     PACKAGES="$PACKAGES $dname"
973     ck=
974     fi
975     fi
976    
977     # Do we need to get rid of $dname according to the dependency rules?
978     if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
979     echo "Error: can't satisfy package dependencies:"
980     echo " \"$pname\" was requested but is disallowed by"
981     echo " the dependency rules for \"$dname\""
982     exit 1
983     fi
984     i=$(( $i + 1 ))
985     done
986     ck=$ck"t"
987     done
988     echo " packages are: $PACKAGES"
989     for i in $PACKAGES ; do
990     adr="$ROOTDIR/pkg/$i"
991     if test -d $adr ; then
992     SOURCEDIRS="$SOURCEDIRS $adr"
993     INCLUDEDIRS="$INCLUDEDIRS $adr"
994 edhill 1.14 if test "x$i" = xautodiff ; then
995     AUTODIFF_PKG_USED=t
996     fi
997 edhill 1.1 else
998     echo "Error: the directory \"$adr\" for package $i doesn't exist"
999     exit 1
1000     fi
1001     done
1002    
1003    
1004 edhill 1.12 # Create a list of #define and #undef to enable/disable packages
1005     PACKAGES_DOT_H=PACKAGES_CONFIG.h
1006     cat <<EOF >$PACKAGES_DOT_H".tmp"
1007 edhill 1.1 C=== GENMAKE v2 ===
1008 edhill 1.11 C The following defines have been set by GENMAKE, so please do not
1009     C edit anything below these comments. In general, you should
1010 edhill 1.1 C add or remove packages by re-running genmake with different
1011     C "-enable" and/or "-disable" options.
1012    
1013 edhill 1.12 #ifndef PACKAGES_H
1014     #define PACKAGES_H
1015    
1016 edhill 1.1 C Packages disabled by genmake:
1017     EOF
1018     # The following UGLY HACK sets multiple "#undef"s and it needs to go
1019     # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1020     # file would eventually be split up so that all package-related #define
1021     # statements could be separated and handled only by genmake.
1022     names=`ls -1 "$ROOTDIR/pkg"`
1023     all_pack=
1024     for n in $names ; do
1025     if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1026     has_pack="f"
1027     for pack in $PACKAGES ; do
1028     if test "x$pack" = "x$n" ; then
1029     has_pack="t"
1030     break
1031     fi
1032     done
1033     if test "x$has_pack" = xf ; then
1034 edhill 1.15 undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1035 edhill 1.12 echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
1036 edhill 1.1 fi
1037     fi
1038     done
1039 edhill 1.12 cat <<EOF >>$PACKAGES_DOT_H".tmp"
1040 edhill 1.1
1041     C Packages enabled by genmake:
1042     EOF
1043     for i in $PACKAGES ; do
1044 edhill 1.15 def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1045 edhill 1.12 echo "#define $def" >> $PACKAGES_DOT_H".tmp"
1046     #eh3 DEFINES="$DEFINES -D$def"
1047 edhill 1.1
1048     #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
1049     case $i in
1050     aim_v23)
1051 edhill 1.12 echo "#define ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
1052     DEFINES="$DEFINES -DALLOW_AIM"
1053     echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
1054 edhill 1.1 ;;
1055     esac
1056     #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
1057    
1058     done
1059 edhill 1.12 cat <<EOF >>$PACKAGES_DOT_H".tmp"
1060    
1061     #endif /* PACKAGES_H */
1062     EOF
1063    
1064     if test ! -f $PACKAGES_DOT_H ; then
1065     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1066     else
1067     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1068     RETVAL=$?
1069     if test "x$RETVAL" = x0 ; then
1070     rm -f $PACKAGES_DOT_H".tmp"
1071     else
1072     mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1073     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1074     fi
1075     fi
1076 edhill 1.1
1077     echo " Adding STANDARDDIRS"
1078     BUILDDIR=${BUILDDIR:-.}
1079 edhill 1.12 if test "x$STANDARDDIRS" = x ; then
1080     STANDARDDIRS="eesupp model"
1081     fi
1082 edhill 1.1 for d in $STANDARDDIRS ; do
1083     adr="$ROOTDIR/$d/src"
1084     if test ! -d $adr ; then
1085     echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1086     echo " is correct and that you correctly specified the STANDARDDIRS option"
1087     exit 1
1088     else
1089     SOURCEDIRS="$SOURCEDIRS $adr"
1090     fi
1091     adr="$ROOTDIR/$d/inc"
1092     if test ! -d $adr ; then
1093     echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1094     echo " is correct and that you correctly specified the STANDARDDIRS option"
1095     exit 1
1096     else
1097     INCLUDEDIRS="$INCLUDEDIRS $adr"
1098     fi
1099     done
1100    
1101 edhill 1.22 echo " Searching for CPP_OPTIONS.h in order to warn about the presence"
1102     echo " of \"#define ALLOW_PKGNAME\"-type statements:"
1103 edhill 1.12 CPP_OPTIONS=
1104     spaths=". $INCLUDEDIRS"
1105     for i in $spaths ; do
1106     try="$i/CPP_OPTIONS.h"
1107     # echo -n " trying $try : "
1108     if test -f $try -a -r $try ; then
1109     echo " found CPP_OPTIONS=\"$try\""
1110     CPP_OPTIONS="$try"
1111     break
1112     fi
1113     done
1114     if test "x$CPP_OPTIONS" = x ; then
1115     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1116     exit 1
1117     fi
1118     # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1119     names=`ls -1 "$ROOTDIR/pkg"`
1120     for n in $names ; do
1121     test_for_package_in_cpp_options $CPP_OPTIONS $n
1122     done
1123    
1124 edhill 1.1
1125 edhill 1.14 # Here, we build the list of files to be "run through" the adjoint
1126     # compiler.
1127     if test -f ./ad_files ; then
1128     rm -f ./ad_files
1129     fi
1130     echo " Creating the list of files for the adjoint compiler."
1131     for i in $SOURCEDIRS ; do
1132     list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1133     for j in $list_files ; do
1134     cat $i/$j >> ad_files
1135     done
1136     done
1137    
1138     cat <<EOF > adjoint_sed
1139     s/call adopen(/call adopen ( mythid,\\
1140     \& /g
1141     s/call adclose(/call adclose( mythid,\\
1142     \& /g
1143     s/call adread(/call adread ( mythid,\\
1144     \& /g
1145     s/call adwrite(/call adwrite( mythid,\\
1146     \& /g
1147    
1148     EOF
1149    
1150 edhill 1.2 echo
1151     echo "=== Creating the Makefile ==="
1152 edhill 1.1 echo " setting INCLUDES"
1153     for i in $INCLUDEDIRS ; do
1154 edhill 1.12 if ! test -d $i ; then
1155     # INCLUDES="$INCLUDES -I$i"
1156     # else
1157 edhill 1.1 echo "Warning: can't find INCLUDEDIRS=\"$i\""
1158     fi
1159     done
1160    
1161     echo " Determining the list of source and include files"
1162     rm -rf .links.tmp
1163     mkdir .links.tmp
1164     echo "# This section creates symbolic links" > srclinks.tmp
1165     echo "" >> srclinks.tmp
1166 cnh 1.3 echo -n 'SRCFILES = ' > srclist.inc
1167     echo -n 'CSRCFILES = ' > csrclist.inc
1168     echo -n 'F90SRCFILES = ' > f90srclist.inc
1169 edhill 1.1 echo -n 'HEADERFILES = ' > hlist.inc
1170 edhill 1.14 echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1171 adcroft 1.9 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1172 edhill 1.1 for d in $alldirs ; do
1173     deplist=
1174 edhill 1.14 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1175 cnh 1.3 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1176 edhill 1.1 for sf in $sfiles ; do
1177     if test ! -r ".links.tmp/$sf" ; then
1178     if test -f "$d/$sf" ; then
1179 edhill 1.15 extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1180 edhill 1.1 touch .links.tmp/$sf
1181     deplist="$deplist $sf"
1182     case $extn in
1183     F)
1184     echo " \\" >> srclist.inc
1185     echo -n " $sf" >> srclist.inc
1186     ;;
1187 cnh 1.3 F90)
1188     echo " \\" >> f90srclist.inc
1189     echo -n " $sf" >> f90srclist.inc
1190     ;;
1191 edhill 1.1 c)
1192     echo " \\" >> csrclist.inc
1193     echo -n " $sf" >> csrclist.inc
1194     ;;
1195     h)
1196     echo " \\" >> hlist.inc
1197     echo -n " $sf" >> hlist.inc
1198     ;;
1199 edhill 1.14 flow)
1200     echo " \\" >> ad_flow_files.inc
1201     echo -n " $sf" >> ad_flow_files.inc
1202     ;;
1203 edhill 1.1 esac
1204     fi
1205     fi
1206     done
1207     if test "x$deplist" != x ; then
1208 edhill 1.2 echo "" >> srclinks.tmp
1209     echo "# These files are linked from $d" >> srclinks.tmp
1210 edhill 1.1 echo "$deplist :" >> srclinks.tmp
1211 edhill 1.2 printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp
1212 edhill 1.1 fi
1213     done
1214     rm -rf .links.tmp
1215     echo "" >> srclist.inc
1216     echo "" >> csrclist.inc
1217 cnh 1.3 echo "" >> f90srclist.inc
1218 edhill 1.1 echo "" >> hlist.inc
1219 edhill 1.14 echo "" >> ad_flow_files.inc
1220 edhill 1.1
1221     if test -e $MAKEFILE ; then
1222     mv -f $MAKEFILE "$MAKEFILE.bak"
1223     fi
1224     echo " Writing makefile: $MAKEFILE"
1225     echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
1226     echo "# $MACHINE" >> $MAKEFILE
1227     echo "# This makefile was generated automatically on" >> $MAKEFILE
1228     echo "# $THISDATE" >> $MAKEFILE
1229     echo "# by the command:" >> $MAKEFILE
1230     echo "# $0 $@" >> $MAKEFILE
1231     echo "# executed by:" >> $MAKEFILE
1232     echo "# $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1233 edhill 1.21
1234     EXE_AD=$EXECUTABLE"_ad"
1235     EXE_FTL=$EXECUTABLE"_ftl"
1236     EXE_SVD=$EXECUTABLE"_svd"
1237    
1238 edhill 1.1 cat >>$MAKEFILE <<EOF
1239     #
1240     # BUILDDIR : Directory where object files are written
1241     # SOURCEDIRS : Directories containing the source (.F) files
1242     # INCLUDEDIRS : Directories containing the header-source (.h) files
1243     # EXEDIR : Directory where executable that is generated is written
1244     # EXECUTABLE : Full path of executable binary
1245     #
1246     # CPP : C-preprocessor command
1247     # INCLUDES : Directories searched for header files
1248     # DEFINES : Macro definitions for CPP
1249     # MAKEDEPEND : Dependency generator
1250     # KPP : Special preprocessor command (specific to platform)
1251     # KFLAGS : Flags for KPP
1252     # FC : Fortran compiler command
1253     # FFLAGS : Configuration/debugging options for FC
1254     # FOPTIM : Optimization options for FC
1255     # LINK : Command for link editor program
1256     # LIBS : Library flags /or/ additional optimization/debugging flags
1257    
1258     ROOTDIR = ${ROOTDIR}
1259     BUILDDIR = ${BUILDDIR}
1260     SOURCEDIRS = ${SOURCEDIRS}
1261     INCLUDEDIRS = ${INCLUDEDIRS}
1262     EXEDIR = ${EXEDIR}
1263     EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
1264     TOOLSDIR = ${TOOLSDIR}
1265    
1266 edhill 1.14 #eh3 new defines for the adjoint work
1267     AUTODIFF = ${ROOTDIR}/pkg/autodiff
1268 edhill 1.21 EXE_AD = ${EXE_AD}
1269     EXE_FTL = ${EXE_FTL}
1270     EXE_SVD = ${EXE_SVD}
1271 edhill 1.14
1272 edhill 1.1 EOF
1273    
1274     # Note: figure out some way to add Hyades JAM libraries here
1275    
1276     cat >>$MAKEFILE <<EOF
1277     # Unix ln (link)
1278     LN = ${LN}
1279     # C preprocessor
1280     CPP = cat \$< | ${S64} | ${CPP}
1281     # Dependency generator
1282     MAKEDEPEND = ${MAKEDEPEND}
1283     # Special preprocessor (KAP on DECs, FPP on Crays)
1284     KPP = ${KPP}
1285     # Fortran compiler
1286     FC = ${FC}
1287 cnh 1.3 # Fortran compiler
1288     F90C = ${F90C}
1289 edhill 1.1 # Link editor
1290     LINK = ${LINK}
1291    
1292     # Defines for CPP
1293     DEFINES = ${DEFINES}
1294     # Includes for CPP
1295     INCLUDES = ${INCLUDES}
1296     # Flags for KPP
1297     KFLAGS1 = ${KFLAGS1}
1298     KFLAGS2 = ${KFLAGS2}
1299     # Optim./debug for FC
1300     FFLAGS = ${FFLAGS}
1301     FOPTIM = ${FOPTIM}
1302 cnh 1.3 # Optim./debug for FC
1303     F90FLAGS = ${F90FLAGS}
1304     F90OPTIM = ${F90OPTIM}
1305 edhill 1.1 # Flags for CC
1306     CFLAGS = ${CFLAGS}
1307     # Files that should not be optimized
1308     NOOPTFILES = ${NOOPTFILES}
1309     NOOPTFLAGS = ${NOOPTFLAGS}
1310     # Flags and libraries needed for linking
1311     LIBS = ${LIBS} \$(XLIBS)
1312 cnh 1.3 # Name of the Mekfile
1313     MAKEFILE=${MAKEFILE}
1314 edhill 1.1
1315     EOF
1316    
1317 edhill 1.14 cat srclist.inc >> $MAKEFILE
1318     cat csrclist.inc >> $MAKEFILE
1319     cat f90srclist.inc >> $MAKEFILE
1320     cat hlist.inc >> $MAKEFILE
1321     cat ad_flow_files.inc >> $MAKEFILE
1322     echo >> $MAKEFILE
1323 cnh 1.3 echo 'F77FILES = $(SRCFILES:.F=.f)' >> $MAKEFILE
1324     echo 'F90FILES = $(F90SRCFILES:.F90=.f90)' >> $MAKEFILE
1325     echo 'OBJFILES = $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1326 edhill 1.1
1327 cnh 1.3 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1328 edhill 1.14 rm -f ad_flow_files.inc
1329 edhill 1.1
1330     cat >>$MAKEFILE <<EOF
1331    
1332     .SUFFIXES:
1333 cnh 1.3 .SUFFIXES: .o .f .p .F .c .F90 .f90
1334 edhill 1.1
1335     all: \$(EXECUTABLE)
1336     \$(EXECUTABLE): \$(OBJFILES)
1337     \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1338     depend:
1339     @make links
1340     \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1341 edhill 1.7 ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)
1342 edhill 1.1
1343 cnh 1.3 links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)
1344 edhill 1.1
1345 cnh 1.3 small_f: \$(F77FILES) \$(F90FILES)
1346 edhill 1.1
1347     output.txt: \$(EXECUTABLE)
1348     @printf 'running ... '
1349     @\$(EXECUTABLE) > \$@
1350    
1351     clean:
1352 edhill 1.22 -cat AD_CONFIG.template > AD_CONFIG.h
1353 cnh 1.3 -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}
1354 edhill 1.1 Clean:
1355     @make clean
1356     @make cleanlinks
1357 edhill 1.22 -rm -f Makefile.bak genmake_state genmake_*optfile make.log
1358 edhill 1.1 CLEAN:
1359     @make Clean
1360     -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1361     -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1362     -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1363 edhill 1.12 -rm -f \$(EXECUTABLE) output.txt
1364 edhill 1.1
1365 edhill 1.18 #eh3 Makefile: makefile
1366 edhill 1.1 makefile:
1367     ${0} $@
1368     cleanlinks:
1369     -find . -type l -exec rm {} \;
1370    
1371     # The normal chain of rules is ( .F - .f - .o )
1372     .F.f:
1373     \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1374     .f.o:
1375     \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1376 cnh 1.3 .F90.f90:
1377     \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1378     .f90.o:
1379     \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1380 edhill 1.1 .c.o:
1381     \$(CC) \$(CFLAGS) -c \$<
1382    
1383     # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain
1384     .F.p:
1385     \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1386     .p.f:
1387     \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1388 edhill 1.14
1389     #=========================================
1390     #=== Automatic Differentiation Rules ===
1391    
1392     TAMC = ${TAMC}
1393     TAF = ${TAF}
1394    
1395 edhill 1.17 TAF_EXTRA = ${TAF_EXTRA}
1396     TAMC_EXTRA = ${TAMC_EXTRA}
1397    
1398 edhill 1.14 EOF
1399    
1400     ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1401     ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1402     ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1403     for i in $ad_vars ; do
1404     name=$i
1405     t1="t2=\$"`echo $i`
1406     eval $t1
1407     printf "%-20s = " $name >> $MAKEFILE
1408     echo $t2 >> $MAKEFILE
1409     done
1410    
1411     echo " Add the source list for AD code generation"
1412     echo >> $MAKEFILE
1413     echo -n "AD_FILES = " >> $MAKEFILE
1414     AD_FILES=`cat ad_files`
1415     for i in $AD_FILES ; do
1416     echo " \\" >> $MAKEFILE
1417     echo -n " $i" >> $MAKEFILE
1418     done
1419     echo >> $MAKEFILE
1420 edhill 1.21 rm -f ad_files
1421 edhill 1.14
1422     cat >>$MAKEFILE <<EOF
1423    
1424 edhill 1.16 # ... AD ...
1425 edhill 1.23 adall: ad_taf
1426     adtaf: ad_taf_output.f
1427     adtamc: ad_tamc_output.f
1428 edhill 1.21
1429 heimbach 1.26 ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1430 edhill 1.23 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1431 edhill 1.22 @make \$(F77FILES)
1432     @make \$(AD_FLOW_FILES)
1433     cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1434    
1435 edhill 1.14 ad_taf_output.f: ad_input_code.f
1436 edhill 1.17 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1437 edhill 1.14 cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1438    
1439     ad_taf: ad_taf_output.o \$(OBJFILES)
1440 edhill 1.21 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1441 edhill 1.14
1442     ad_tamc_output.f: ad_input_code.f
1443 edhill 1.17 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1444 edhill 1.16 cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f
1445 edhill 1.14
1446     ad_tamc: ad_tamc_output.o \$(OBJFILES)
1447 edhill 1.21 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1448 edhill 1.14
1449    
1450 edhill 1.19 # ... FTL ...
1451 edhill 1.23 ftlall: ftl_taf
1452     ftltaf: ftl_taf_output.f
1453     ftltamc: ftl_tamc_output.f
1454 edhill 1.21
1455 heimbach 1.26 ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1456 edhill 1.23 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1457     @make \$(F77FILES)
1458 edhill 1.22 @make \$(AD_FLOW_FILES)
1459     cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1460    
1461     ftl_taf_output.f: ftl_input_code.f
1462     \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1463     cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f
1464 edhill 1.14
1465 edhill 1.19 ftl_taf: ftl_taf_output.o \$(OBJFILES)
1466 edhill 1.21 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1467 edhill 1.14
1468 edhill 1.22 ftl_tamc_output.f: ftl_input_code.f
1469     \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1470     cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f
1471 edhill 1.16
1472 edhill 1.19 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1473 edhill 1.21 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1474 edhill 1.16
1475    
1476     # ... SVD ...
1477 edhill 1.21 svd: svd_taf
1478     svd_taf_f: svd_taf_output.f
1479    
1480 edhill 1.22 svd_input_code.f: \$(SRCFILES)
1481 edhill 1.23 cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h
1482     @make \$(F77FILES)
1483 edhill 1.22 @make \$(AD_FLOW_FILES)
1484     cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f
1485    
1486     svd_taf_output.f: svd_input_code.f
1487     \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f
1488     cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f
1489 edhill 1.16
1490     svd_taf: svd_taf_output.o \$(OBJFILES)
1491 edhill 1.21 \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)
1492 edhill 1.14
1493    
1494     #=========================================
1495 edhill 1.1
1496     EOF
1497 edhill 1.7
1498     if test "x$EXEHOOK" != x ; then
1499     printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
1500     fi
1501 edhill 1.1
1502     echo " Making list of \"exceptions\" that need \".p\" files"
1503     for i in $KPPFILES ; do
1504     base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
1505     RETVAL=$?
1506     if test "x$RETVAL" != x0 ; then
1507     echo "Error: unable to add file \"$i\" to the exceptions list"
1508     fi
1509     echo "$base.f: $base.p" >> $MAKEFILE
1510     done
1511    
1512     echo " Making list of NOOPTFILES"
1513     for i in $NOOPTFILES ; do
1514     base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
1515     RETVAL=$?
1516     if test "x$RETVAL" != x0 ; then
1517     echo "Error: unable to add file \"$i\" to the exceptions list"
1518     fi
1519     echo "$base.o: $base.f" >> $MAKEFILE
1520 edhill 1.2 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
1521 edhill 1.1 done
1522    
1523     echo " Add rules for links"
1524     cat srclinks.tmp >> $MAKEFILE
1525     rm -f srclinks.tmp
1526    
1527     echo " Adding makedepend marker"
1528 edhill 1.2 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
1529 edhill 1.1
1530 edhill 1.2 printf "\n=== Done ===\n"
1531 edhill 1.22
1532     # Write the "template" files for the adjoint builds
1533 edhill 1.23 cat >AD_CONFIG.template <<EOF
1534 edhill 1.22 C WARNING: This file is automatically generated by genmake2 and
1535     C used by the Makefile rules. Please DO NOT EDIT this file
1536 edhill 1.23 C unless you are CERTAIN that you know what you are doing.
1537 edhill 1.22
1538     #undef ALLOW_ADJOINT_RUN
1539     #undef ALLOW_TANGENTLINEAR_RUN
1540     #undef ALLOW_ECCO_OPTIMIZATION
1541     EOF
1542 edhill 1.23 cat >ad_config.template <<EOF
1543 edhill 1.22 C WARNING: This file is automatically generated by genmake2 and
1544     C used by the Makefile rules. Please DO NOT EDIT this file
1545 edhill 1.23 C unless you are CERTAIN that you know what you are doing.
1546 edhill 1.22
1547 edhill 1.23 #define ALLOW_ADJOINT_RUN
1548 edhill 1.22 #undef ALLOW_TANGENTLINEAR_RUN
1549     #undef ALLOW_ECCO_OPTIMIZATION
1550     EOF
1551 edhill 1.23 cat >ftl_config.template <<EOF
1552 edhill 1.22 C WARNING: This file is automatically generated by genmake2 and
1553     C used by the Makefile rules. Please DO NOT EDIT this file
1554 edhill 1.23 C unless you are CERTAIN that you know what you are doing.
1555 edhill 1.22
1556     #undef ALLOW_ADJOINT_RUN
1557 edhill 1.23 #define ALLOW_TANGENTLINEAR_RUN
1558 edhill 1.22 #undef ALLOW_ECCO_OPTIMIZATION
1559     EOF
1560 edhill 1.23 cat >svd_config.template <<EOF
1561 edhill 1.22 C WARNING: This file is automatically generated by genmake2 and
1562     C used by the Makefile rules. Please DO NOT EDIT this file
1563 edhill 1.23 C unless you are CERTAIN that you know what you are doing.
1564 edhill 1.22
1565     #undef ALLOW_ADJOINT_RUN
1566     #undef ALLOW_TANGENTLINEAR_RUN
1567     #undef ALLOW_ECCO_OPTIMIZATION
1568     EOF
1569     cp AD_CONFIG.template AD_CONFIG.h
1570 edhill 1.5
1571    
1572     # Write the "state" for future records
1573     if test "x$DUMPSTATE" != xf ; then
1574 edhill 1.12 echo -n "" > genmake_state
1575 edhill 1.5 for i in $gm_state ; do
1576     t1="t2=\$$i"
1577     eval $t1
1578 edhill 1.12 echo "$i='$t2'" >> genmake_state
1579 edhill 1.5 done
1580     fi

  ViewVC Help
Powered by ViewVC 1.1.22